%if 0%{?fedora} >= 11
%bcond_without python3
%bcond_without documentation
%else
%bcond_with python3
%bcond_with documentation
%endif

%global modname parse_type

Name:               python-%{modname}
Version:            0.3.4
Release:            2%{?dist}
Summary:            Simplifies to build parse types based on the parse module

Group:              Development/Libraries
License:            BSD
URL:                http://pypi.python.org/pypi/parse_type
Source0:            http://pypi.python.org/packages/source/p/%{modname}/%{modname}-%{version}.tar.gz
Patch0:             parse_type-build.patch
Patch1:             dont-build-docs.patch

BuildArch:          noarch
BuildRequires:      python2-devel, python-setuptools
BuildRequires:      python-six, python-parse >= 1.6
%if %{with documentation}
BuildRequires:      python-sphinx >= 1.1
%endif
%if 0%{?rhel} <= 6
BuildRequires:      python-unittest2
%endif
BuildRequires:      python-enum34

%if %{with python3}
BuildRequires:      python3-devel
BuildRequires:      python3-six, python3-parse >= 1.6, python3-enum34
BuildRequires:      python3-setuptools, python3-enum34
%if %{with documentation}
BuildRequires:      python3-sphinx >= 1.1
%endif
%endif
Requires:           python-six, python-parse >= 1.6, python-enum34

%description
`parse_type`_ extends the `parse`_ module (opposite of
`string.format()`_) with the following features:

    * build type converters for common use cases (enum/mapping, choice)
    * build a type converter with a cardinality constraint (0..1,
      0..*, 1..*) from the type converter with cardinality=1.
    * compose a type converter from other type converters
    * an extended parser that supports the CardinalityField naming
      schema and creates missing type variants (0..1, 0..*, 1..*) from
      the primary type converter


%if %{with python3}
%package -n python3-parse_type
Summary:            Simplifies to build parse types based on the parse module
Group:              Development/Libraries
Requires:           python3-six, python3-parse >= 1.6, python3-enum34

%description -n python3-parse_type
`parse_type`_ extends the `parse`_ module (opposite of
`string.format()`_) with the following features:

    * build type converters for common use cases (enum/mapping, choice)
    * build a type converter with a cardinality constraint (0..1,
      0..*, 1..*) from the type converter with cardinality=1.
    * compose a type converter from other type converters
    * an extended parser that supports the CardinalityField naming
      schema and creates missing type variants (0..1, 0..*, 1..*) from
      the primary type converter

This is the python3 version of the package.
%endif

%prep
%setup -q -n %{modname}-%{version}
%patch0 -p1

%if %{without documentation}
%patch1 -p1
%endif

# Remove bundled egg-info in case it exists
rm -rf %{modname}.egg-info
%if %{with python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
%endif

%build
%{__python} setup.py build
%if %{with python3}
pushd %{py3dir}
%{__python3} setup.py build
popd
%endif


%install
export PYSETUP_TEST="no"
%if %{with python3}
pushd %{py3dir}
%{__python3} setup.py install -O1 --skip-build --root=%{buildroot}
popd
%endif
%{__python} setup.py install -O1 --skip-build --root=%{buildroot}

%check
%{__python} setup.py test
%if %{with python3}
pushd %{py3dir}
%{__python3} setup.py test
popd
%endif

%files
%doc README.rst LICENSE
%{python_sitelib}/%{modname}/
%{python_sitelib}/%{modname}-%{version}*
%{python_sitelib}/_paver_ext/

%if %{with python3}
%files -n python3-parse_type
%doc README.rst LICENSE
%{python3_sitelib}/%{modname}/
%{python3_sitelib}/%{modname}-%{version}-*
%{python3_sitelib}/_paver_ext/
%endif

%changelog
* Thu Jun 19 2014 Matěj Cepl <mcepl@redhat.com> - 0.3.4-1
- initial package for Fedora
